
function fileToString(file) {
    // Get a nsIFileInputStream for the file
    var fis = Components.classes["@mozilla.org/network/file-input-stream;1"]
                        .createInstance(Components.interfaces.nsIFileInputStream);
    fis.init(file, -1, 0, 0);
    
    // Get an intl-aware nsIConverterInputStream for the file
    const replacementChar = Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER;
    var is = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
                       .createInstance(Components.interfaces.nsIConverterInputStream);
    is.init(fis, "UTF-8", 1024, replacementChar);
    
    // Read the file into str
    var str = "";
    var tempStr = {};
    while (is.readString(4096, tempStr) != 0) {
        str += tempStr.value;
    }
    
    // Clean up
    is.close();
    fis.close();
    alert(str);
    return str;
}

function stringToFile(str, file) {
    // Get a nsIFileOutputStream for the file
    var fos = Components.classes["@mozilla.org/network/file-output-stream;1"]
                        .createInstance(Components.interfaces.nsIFileOutputStream);
    fos.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write | create | truncate
    
    // Get an intl-aware nsIConverterOutputStream for the file
    var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
                       .createInstance(Components.interfaces.nsIConverterOutputStream);
    os.init(fos, "UTF-8", 0, 0x0000);
    
    // Write str to the file
    os.writeString(str);
    
    // Clean up
    os.close();
    fos.close();
}
