
var snippetManager = {
  app : null,
  snippets : [],
  categories : [],
  
  init : function(aApp, aFileName) {
    app = aApp;

    var req = new XMLHttpRequest();
    req.open("GET", aFileName, false); 
    req.send(null);
  
    this.snippets = eval("(" + req.responseText + ")");

    for (var i in this.snippets) {
      if (this.categories.indexOf(this.snippets[i].category) == -1)
        this.categories[i] = this.snippets[i].category;
    }
    
    this.categories.sort(function(a, b) {
        return (a < b) ? -1 : 1;
      }
    );
  },

  filterByCategory : function(categoryIndex) {
    var filtered = [];
    if (categoryIndex == -1) {
      filtered = this.snippets;
    }
    else {
      for (var i in this.snippets) {
        if (this.snippets[i].category == this.categories[categoryIndex])
          filtered[i] = this.snippets[i];
      }
    }
    return filtered;
  },
    
  insert : function(snippet) {
    var snippetCode = this.snippets[snippet].code;
    snippetCode = snippetCode.replace(/^\s*/,"").replace(/\s*$/,"");
    app.insertText(snippetCode);      
  }
};
